/*
 * Copyright 2010-2014 Ning, Inc.
 * Copyright 2014-2020 Groupon, Inc
 * Copyright 2020-2021 Equinix, Inc
 * Copyright 2014-2021 The Billing Project, LLC
 *
 * The Billing Project licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */


package org.killbill.billing.client.model.gen;

import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;
import org.killbill.billing.ObjectType;
import org.killbill.billing.client.model.gen.AuditLog;

/**
 *           DO NOT EDIT !!!
 *
 * This code has been generated by the Kill Bill swagger generator.
 *  @See https://github.com/killbill/killbill-swagger-coden
 */
import org.killbill.billing.client.model.KillBillObject;

public class CustomField extends KillBillObject {

    private UUID customFieldId = null;

    private UUID objectId = null;

    private ObjectType objectType = null;

    private String name = null;

    private String value = null;



    public CustomField() {
    }

    public CustomField(final UUID customFieldId,
                     final UUID objectId,
                     final ObjectType objectType,
                     final String name,
                     final String value,
                     final List<AuditLog> auditLogs) {
        super(auditLogs);
        this.customFieldId = customFieldId;
        this.objectId = objectId;
        this.objectType = objectType;
        this.name = name;
        this.value = value;

    }


    public CustomField setCustomFieldId(final UUID customFieldId) {
        this.customFieldId = customFieldId;
        return this;
    }

    public UUID getCustomFieldId() {
        return customFieldId;
    }

    public CustomField setObjectId(final UUID objectId) {
        this.objectId = objectId;
        return this;
    }

    public UUID getObjectId() {
        return objectId;
    }

    public CustomField setObjectType(final ObjectType objectType) {
        this.objectType = objectType;
        return this;
    }

    public ObjectType getObjectType() {
        return objectType;
    }

    public CustomField setName(final String name) {
        this.name = name;
        return this;
    }

    public String getName() {
        return name;
    }

    public CustomField setValue(final String value) {
        this.value = value;
        return this;
    }

    public String getValue() {
        return value;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        CustomField customField = (CustomField) o;
        return Objects.equals(this.customFieldId, customField.customFieldId) &&
            Objects.equals(this.objectId, customField.objectId) &&
            Objects.equals(this.objectType, customField.objectType) &&
            Objects.equals(this.name, customField.name) &&
            Objects.equals(this.value, customField.value) &&
            true /* ignoring this.auditLogs for identity operations */;
    }

    @Override
    public int hashCode() {
        return Objects.hash(customFieldId,
            objectId,
            objectType,
            name,
            value,
            0 /* ignoring auditLogs for identity operations */ );
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class CustomField {\n");
        sb.append("    ").append(toIndentedString(super.toString())).append("\n");
        sb.append("    customFieldId: ").append(toIndentedString(customFieldId)).append("\n");
        sb.append("    objectId: ").append(toIndentedString(objectId)).append("\n");
        sb.append("    objectType: ").append(toIndentedString(objectType)).append("\n");
        sb.append("    name: ").append(toIndentedString(name)).append("\n");
        sb.append("    value: ").append(toIndentedString(value)).append("\n");
        sb.append("    auditLogs: ").append(toIndentedString(auditLogs)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

